#include <string>

#include "autoptr.h"

typedef long double evaltype;
typedef unsigned long long longtype;

typedef autoptr<class expr> exprp;
class expr : public ptrable
{
	enum { prio_none = 0, prio_add, prio_modulo, prio_times, prio_nega, prio_expon, prio_huuto };
public:
	bool ok;
	expr() : ok(true) { }
	exprp load(string &s, int base, int prio = prio_none);
	virtual evaltype eval() const { return 0; }
};

extern string expr_expect;
